/* -*- c++ -*-
   SharedMedia.h
   $Id: sharedmedia.h,v 1.1.1.1 2000/08/28 18:40:07 jinyang Exp $

   a SharedMedia network interface

*/

#ifndef _cmu_SharedMedia_h_
#define _cmu_SharedMedia_h_

#include <cmu/net-if.h>
#include <cmu/omni-antenna.h>

class SharedMedia : public NetIf {
public:
  SharedMedia();

  virtual void xmitPacket(Packet *p);
  virtual int recvPacket(Packet *p, double *RxPr);
  
  inline double getL() {return L;}
  inline double getLambda() {return lambda;}

  virtual int command(int argc, const char*const* argv);

  virtual void dump(void) const;
  
protected:
  double Pt;			// transmission power (W)
  double freq;                  // frequency
  double lambda;		// wavelength (m)
  double L;			// system loss factor
  
  double RXThresh;		// receive power threshold (W)
  double CSThresh;		// carrier sense threshold (W)
  double CPThresh;		// capture threshold (db)
  
  Antenna *ant;
};

#endif _cmu_SharedMedia_h_
